import { createDynamicScopeExpression } from '../../src/dynamic-scope'

test('Arrow function: () => {}', () => {
  const arrow1 = () => {
    return message
  }
  const arrow2 = () => message

  const scope1 = createDynamicScopeExpression(arrow1)
  const func1 = eval(scope1)({ message: 'Hello World!' })

  const scope2 = createDynamicScopeExpression(arrow2)
  const func2 = eval(scope2)({ message: 'Hello World!' })

  expect(func1()).toEqual('Hello World!')
  expect(func2()).toEqual('Hello World!')
})

test('Async arrow function: async () => {}', async () => {
  const arrow1 = async () => {
    return message
  }
  const arrow2 = async () => message

  const scope1 = createDynamicScopeExpression(arrow1)
  const func1 = eval(scope1)({ message: 'Hello World!' })

  const scope2 = createDynamicScopeExpression(arrow2)
  const func2 = eval(scope2)({ message: 'Hello World!' })

  expect(await func1()).toEqual('Hello World!')
  expect(await func2()).toEqual('Hello World!')
})
