import { createDynamicScopeExpression } from '../../../src/dynamic-scope'

test('Class normal name function: func() {}', async () => {
  const obj = {
    func1() {
      return message
    }
  , async func2() {
      return message
    }
  }

  const scope1 = createDynamicScopeExpression(obj.func1)
  const func1 = eval(scope1)({ message: 'Hello World!' })

  const scope2 = createDynamicScopeExpression(obj.func2)
  const func2 = eval(scope2)({ message: 'Hello World!' })

  expect(func1()).toEqual('Hello World!')
  expect(await func2()).toEqual('Hello World!')
})

test("Class unnormal name function(Node.js harmony, Firefox): ['*']() {}", async () => {
  const obj = {
    ['*']() {
      return message
    }
  , async ['[']() {
      return message
    }
  }

  const scope1 = createDynamicScopeExpression(obj['*'])
  const func1 = eval(scope1)({ message: 'Hello World!' })

  const scope2 = createDynamicScopeExpression(obj['['])
  const func2 = eval(scope2)({ message: 'Hello World!' })

  expect(func1()).toEqual('Hello World!')
  expect(await func2()).toEqual('Hello World!')
})

test('Class unnormal name function(Node.js harmony, Firefox): ["*"]() {}', async () => {
  const obj = {
    ["*"]() {
      return message
    }
  , async ["["]() {
      return message
    }
  }

  const scope1 = createDynamicScopeExpression(obj['*'])
  const func1 = eval(scope1)({ message: 'Hello World!' })

  const scope2 = createDynamicScopeExpression(obj['['])
  const func2 = eval(scope2)({ message: 'Hello World!' })

  expect(func1()).toEqual('Hello World!')
  expect(await func2()).toEqual('Hello World!')
})

test('Class unnormal name function(Node.js harmony, Firefox): [`*`]() {}', async () => {
  const obj = {
    [`*`]() {
      return message
    }
  , async [`[`]() {
      return message
    }
  }

  const scope1 = createDynamicScopeExpression(obj['*'])
  const func1 = eval(scope1)({ message: 'Hello World!' })

  const scope2 = createDynamicScopeExpression(obj['['])
  const func2 = eval(scope2)({ message: 'Hello World!' })

  expect(func1()).toEqual('Hello World!')
  expect(await func2()).toEqual('Hello World!')
})
