import { createDynamicScopeExpression } from '../../src/dynamic-scope'

test('Native function: function abs() { [native code] }', () => {
  const func = Math.abs

  expect(() => createDynamicScopeExpression(func)).toThrow(TypeError)
})

test('Function: function named() {}', () => {
  function named() {
    return message
  }

  const scope = createDynamicScopeExpression(named)
  const func = eval(scope)({ message: 'Hello World!' })

  expect(func()).toEqual('Hello World!')
})

test('Anonymous function: function() {}', () => {
  const anonymous = function() {
    return message
  }

  const scope = createDynamicScopeExpression(anonymous)
  const func = eval(scope)({ message: 'Hello World!' })

  expect(func()).toEqual('Hello World!')
})

test('Async function: async function named() {}', async () => {
  async function named() {
    return message
  }

  const scope = createDynamicScopeExpression(named)
  const func = eval(scope)({ message: 'Hello World!'})

  expect(await func()).toEqual('Hello World!')
})

test('Anonymous async function: async function() {}', async () => {
  const anonymous = async function() {
    return message
  }

  const scope = createDynamicScopeExpression(anonymous)
  const func = eval(scope)({ message: 'Hello World!' })

  expect(await func()).toEqual('Hello World!')
})
