import { createDynamicScopeExpression } from '../src/dynamic-scope'

test('Complete dynamic scope implementation in non-strict mode', () => {
  function named() {
    return message
  }

  const scope = createDynamicScopeExpression(named)
  const message = 'Hello World!'
  const func = eval(scope)()

  expect(func()).toEqual('Hello World!')
})

test('Incomplete dynamic scope implementation in strict mode', () => {
  'use strict'

  function named() {
    return message
  }

  const scope = createDynamicScopeExpression(named)
  const message = 'Hello World!'
  const func = eval(scope)()

  expect(func).toThrow(ReferenceError)
})
